let getEmail editor () =
  let us= Wid.the_mask [ "eMail:  ############################################"] in
		Wid.set_mask us editor;;

let getZip editor () =
  let us= Wid.the_mask ["Zip Code  :  #############    "  ] in
		Wid.set_mask us editor;;  

(* just a shell to process the text with the mask *)
let processa s= s;;

let main () = 
	Wid.open_gr "eMacs like Editor - Gui Example";
	let msk= Wid.the_mask ["First Name: ###############  "; 
	                       "Last Name:  ###############  ";
	                       "Nick Name:  #####            "] in
	let ed =  Wid.mk_edt ~txt:(Wid.nlines 20) ~fn:(fun x -> (String.uppercase x)) "Editor"  and
		 frm = Wid.mk_entry ~txt:msk ~fn:processa "Form"  in
	let ext= Wid.exit_button() and
		 email= Wid.button 0 (getEmail "Form") "Email" and
		 zipcd= Wid.button 1 (getZip "Form") "Zip code" 
	in
	while true do
		Wid.refresh ();
		ed.Wid.process_event();
		frm.Wid.process_event();
		email.Wid.process_event();
		zipcd.Wid.process_event();
		ext.Wid.process_event()	
	done;
	Wid.close_gr();;   
 
main ();;