
let rec factorial n=
   if n<1 then 1 else n*factorial(n-1);;

let facfun txt= match Wid.getFloatList txt with
      (x::xs) -> string_of_int(factorial (int_of_float x))
   | any -> " ";;

let main () = 
	Wid.open_gr "Fatorial";
	let ed = Wid.mk_edt ~txt:(Wid.nlines 20) ~fn:facfun "factorial" 
	and ext= Wid.exit_button() 
	in
	
	while true do
	   Wid.refresh ();
		ed.Wid.process_event();
		ext.Wid.process_event()	
	done;
	Wid.close_gr();;   
 
main ();;